// $Id$

//=============================================================================
/**
 *  @file    rcmd_message.cpp
 *
 *  @author  Fukasawa Mitsuo
 *
 *
 *    Copyright (C) 2004 BEE Co.,Ltd. All rights reserved.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
//=============================================================================

#include "vfei_message.h"

namespace jyugem { namespace cell
{

BS2Message * rcmd_message::make_secs()
{
    BS2Message * secsmsg;
    BS2ListItem * rootlist = new BS2ListItem();
    BS2ListItem * paramlist = new BS2ListItem();
    BS2Item * rcmd = this->rcmdItem();
    if (m_msgtype->m_algorithm == _TX("S2F49"))
    {
        secsmsg = secs_begin(SFCODE(2,49));
        JGid tid(m_tid);
        BS2Item * dataid  = BS2Item::factory(_TX("DATAID"), tid);
        rootlist->add(dataid);
        rootlist->add(rcmd);
        // search objtype
        JGvalue oid(m_oid);
        BS2Item * dataid  = BS2Item::factory(_TX("DATAID"), oid);
    }
    else
    {
        secsmsg = secs_begin(SFCODE(2,41));
        rootlist->add(rcmd);
    }


    make_param(paramlist);

    rootlist->add(paramlist);
    secsmsg->add(rootlist);

    return secsmsg;
}


} }  // *jyugem::cell*
