// $Id$

//=============================================================================
/**
 *  @file    res_transfer_message.cpp
 *
 *  @author  Fukasawa Mitsuo
 *
 *
 *    Copyright (C) 2004 BEE Co.,Ltd. All rights reserved.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
//=============================================================================
#define BEE_BUILD_DLL

#include "jyugem/cell/host_message.h"

namespace jyugem { namespace cell
{

void res_transfer_message::append(const any_item& mbr)
{
    TRACE_FUNCTION(TRL_LOW, "res_transfer_message::append");
    if (mbr.name() == "TYPE")
    {
        m_type = mbr.m_value.toString();
    }
    else if (mbr.name() == "RESOURCE_ID")
    {
        m_resid = mbr.m_value.toString();
    }
    else if (mbr.name() == "RESOURCE_LENGTH")
    {
        m_length = mbr.m_value.getInt();
    }
    else if (mbr.name() == "RESOURCE_BODY")
    {
        // read recipe body from file !? 
        m_body = mbr.m_value.toString().c_str();
    }
    else if (mbr.name() == "RESOURCE_FILE")
    {
        m_file = mbr.m_value.toString();
    }
    else if (mbr.name() == "SOURCE")
    {
        m_src = mbr.m_value.toString();
    }
    else if (mbr.name() == "DESTINATION")
    {
        m_dest = mbr.m_value.toString();
    }
    this->rcmd::append(mbr);
}

} }  // *jyugem::cell*
